/*Simon Says game. Now with sound effects. 
Originaly made by Robert Spann
Original code trimmed by digimike
This code varies alot from the original code
That is because Simon Says now has some new features:
  - LED's are replaced with a NeoPixel Ring with 16 RGB LED's
  - Sounds from the games Mario Bros., The Legend Of Zelda and Sonic The Hedgehog
  - Point system made with two sound effects (low Mario coin sound and the real Mario coin sound) and two light effects
  - Buttons are replaced with self-made capacative touchpads
All these features are coded by Mick Gerritsen
*/
#include "pitches.h"
#include "neopixelRing.h"
#include "fsr.h"
#include <EEPROM.h>

int speakerpin = 12;
int starttune[] = {NOTE_E5, NOTE_E5, NOTE_E5, NOTE_C5, NOTE_E5, NOTE_G5, NOTE_G4};
int duration2[] = {125, 250, 250, 125, 250, 500, 500};
int note[] = {NOTE_A4, NOTE_AS4, NOTE_B4, NOTE_C5};
int duration[] = {200, 200, 200, 800};
int gameovertune[] = {NOTE_C4, NOTE_C4, NOTE_B3, NOTE_AS3, NOTE_A3, NOTE_G3};
int duration3[] = {150, 150, 300, 300, 300, 1200};
int button[] = {2, 3, 4, 5}; //The four button input pins
int ledpin[] = {8, 9, 10, 11};  // LED pins
int turn = 0;  // turn counter
int buttonstate = 0;  // button state checker
int colorArray[100]; //Intentionally long to store up to 100 inputs (doubtful anyone will get this far)
int inputArray[100];  
int tens = 0;
int ones = 0;
int hitens;
int hiones;
int highscoredelay = 30;
bool highScoreShow = false;
bool fail1 = false;
int addr1 = 0;
int addr2 = 1;
int addrspeed = 2;
bool restart = false;
bool startupTone = true;
//int pace = EEPROM.read(addrspeed);
int pace = 4;
void setup() 
{
  //hiones = EEPROM.read(0);
  //EEPROM.write(0,0);
  setupFsr();
  fsrRead3();
    // This is for Trinket 5V 16MHz, you can remove these three lines if you are not using a Trinket
  #if defined (__AVR_ATtiny85__)
    if (F_CPU == 16000000) clock_prescale_set(clock_div_1);
  #endif
  // End of trinket special code
    strip.begin();
  strip.show(); // Initialize all pixels to 'off'
  Serial.begin(9600);
  Serial.println(EEPROM.read(addr1));
  Serial.println(EEPROM.read(addr2));
  pace = EEPROM.read(addrspeed);
  randomSeed(analogRead(0)); //Added to generate "more randomness" with the colorArray for the output function
  for (int thisNote = 0; thisNote < 7; thisNote ++) {
     // play the next note:
     // Play the startup tune
     tone(speakerpin, starttune[thisNote]);
     // hold the note:
     if (thisNote==3)
     {
       topLeft();
     }
     if (thisNote==0 || thisNote==1 || thisNote==2)
     {
       botLeft();
     }
     if (thisNote==4 || thisNote==6)
     {
       botRight();
     }  
     if (thisNote==5)
     {   
       topRight();
     }
     delay(duration2[thisNote]);
     // stop for the next note:
     noTone(speakerpin);
     //Startup melody to remain NeoPixel off while between notes
     pixelsOff();
     delay(25);
    }
  delay(200);
}
 
void loop() 
{ 
  start();
}
void start(){
    Serial.println("restart");
    colorCycle(50);
    fsrRead1();
    fsrRead2();
    fsrRead3();
    fsrRead4();
    topLeft();
    botLeft();
    botRight();
    topRight();
    Serial.println(treshold);
    if (startupTone == true){
      tone(speakerpin, NOTE_E5, 100);
      delay(100);
      tone(speakerpin, NOTE_C5, 100);
      delay(100);
      tone(speakerpin, NOTE_E5, 100);
      delay(100);
      tone(speakerpin, NOTE_C5, 100);
      delay(100);
      startupTone = false;
      }
    
    if (touchInput1 == true){
      pixelsOff();
      topLeft();
      tone(speakerpin, NOTE_G3, 100);
      delay(200);
      restart = false;
      startupTone = true;
      turn = 0;
      mainGame();
      }
        if (touchInput2 == true){
        pixelsOff();
        botLeft();
        tone(speakerpin, NOTE_A3, 100);
        delay(400);
        startupTone = true;
        if (pace == 1){
            pace = 4;
          }
        else if (pace == 2){
            pace = 1;
          }
        else if (pace == 3){
            pace = 2;
        }
        else if (pace == 4){
            pace = 3;
          }
        EEPROM.write(addrspeed, pace);
        colorCircle(blue);
        tone(speakerpin, NOTE_B4, 150*pace);
        delay(200*pace);
        pixelsOff();
        colorCircle(blue);
        tone(speakerpin, NOTE_A4, 150*pace);
        delay(200*pace);
        pixelsOff();
        colorCircle(blue);
        tone(speakerpin, NOTE_B4, 150*pace);
        delay(200*pace);
        pixelsOff();
        colorCircle(blue);
        tone(speakerpin, NOTE_A4, 150*pace);
        delay(200*pace);
        pixelsOff();
        colorCircle(blue);
        tone(speakerpin, NOTE_B4, 150*pace);
        delay(150*pace);
        pixelsOff();
        colorCircle(blue);
        tone(speakerpin, NOTE_A4, 150*pace);
        delay(150*pace);
        pixelsOff();
        colorCircle(blue);
        tone(speakerpin, NOTE_C5, 150*pace);
        delay(200*pace);
        pixelsOff();
        colorCircle(blue);
        tone(speakerpin, NOTE_B4, 150*pace);
        delay(200*pace);
        pixelsOff();
        colorCircle(blue);
        tone(speakerpin, NOTE_A4, 400*pace);
        delay(400*pace);
        pixelsOff();
      }
    if (touchInput3 == true){
      pixelsOff();
      botRight();
      startupTone = true;
      tone(speakerpin, NOTE_B3, 100);
      delay(200);
      highScore(blue, yellow);
    }
    if (touchInput4 == true){
      pixelsOff();
      topRight();
      startupTone = true;
      tone(speakerpin, NOTE_B3, 100);
      delay(200);
      tone(speakerpin, NOTE_G5, 100);
      delay(120);
      tone(speakerpin, NOTE_FS5, 100);
      delay(120);
      tone(speakerpin, NOTE_DS5, 100);
      delay(120);
      tone(speakerpin, NOTE_A4, 100);
      delay(120);
      tone(speakerpin, NOTE_AS4, 100);
      delay(120);
      tone(speakerpin, NOTE_E5, 100);
      delay(120);
      tone(speakerpin, NOTE_AS5, 100);
      delay(120);
      tone(speakerpin, NOTE_C6, 300);
      delay(720);
    }
  }
 
 
void input() { //Function for allowing user input and checking input against the generated array
  for (int x=0; x <= turn;)
  { //Statement controlled by turn count

    for(int y=0; y<4; y++)
    {
      //these functions need give a boolean if a certain pad is pushed/touched
      fsrRead1();
      fsrRead2();
      fsrRead3();
      fsrRead4();
      if (touchInput1 == true)
      { //Checking for button push
        //Turn on LED when button pushed
        //digitalWrite(ledpin[0], HIGH);
        topLeft();
        tone(speakerpin, NOTE_G3, 100);
        delay(300);
        //Turn off LED after button push
        //digitalWrite(ledpin[0], LOW);
        pixelsOff();
        inputArray[x] = 1;
        Serial.print(" ");
        Serial.print(1);
        if (inputArray[x] != colorArray[x]) { //Checks value input by user and checks it against
          fail();                              //the value in the same spot on the generated array
        }                                      //The fail function is called if it does not match
        x++;
      }
      
       if (touchInput2 == true)
      {
        botLeft();
        tone(speakerpin, NOTE_A3, 100);
        delay(300);
        pixelsOff();
        inputArray[x] = 2;
        Serial.print(" ");
        Serial.print(2);
        if (inputArray[x] != colorArray[x]) {
          fail();
        }
        x++;
      }

      if (touchInput3 == true)
      {
        botRight();
        tone(speakerpin, NOTE_B3, 100);
        delay(300);
        pixelsOff();
        inputArray[x] = 3;
        Serial.print(" ");
        Serial.print(3);
        if (inputArray[x] != colorArray[x]) {
          fail();
        }
        x++;
      }
      if (touchInput4 == true)
      {
        Serial.println("touched");
        topRight();
        tone(speakerpin, NOTE_C4, 100);
        delay(300);
        pixelsOff();
        inputArray[x] = 4;
        Serial.print(" ");
        Serial.print(4);
        if (inputArray[x] != colorArray[x]) 
        {
          fail();
        }
        x++;
      }
    }
  }
  turn++; //Increments the turn count, also the last action before starting the output function over again
  }
  

void fail() { //Function used if the player fails to match the sequence
 delay(200);
 for (int thisNote = 0; thisNote < 6; thisNote ++) {
     // play the next note:
     // Play the startup tune
     tone(speakerpin, gameovertune[thisNote]);
     // hold the note:
     if (thisNote==1 || thisNote==3 || thisNote==5)
     {
       gameOver();
     }
     if (thisNote==0 || thisNote==2 || thisNote==4)
     {
       pixelsOff();
     }
     delay(duration3[thisNote]);
     noTone(speakerpin);
 }
  delay(500);
  //start();
  pointCounter(blue, yellow, tens, ones);
}

void mainGame(){
  for (int y=0; y<=99; y++)
  {  Serial.print("main game");
    if (turn == 0){
      colorCycle(50);
      topLeft();
      botLeft();
      botRight();
      topRight();
      delay(100);
    }
    else{
    delay(200);
    victory();
    }
    for (int thisNote = 0; thisNote < 4; thisNote ++) {
     // play the next note:
     tone(speakerpin, note[thisNote]);
     // hold the note:
     delay(duration[thisNote]);
     // stop for the next note:
     noTone(speakerpin);
     delay(25);
    }
    delay(500);
    //Melody to remain NeoPixel off while between notes
    pixelsOff();
    delay(1000);
    
    for (int y=turn; y <= turn; y++)
    { //Limited by the turn variable
      tens = y/10;
      ones = y-tens*10;
      Serial.println(""); //Some serial output to follow along
      Serial.print("Turn: ");
      Serial.print(y);
      Serial.println("");
      Serial.print("10s: ");
      Serial.print(tens);
      Serial.println("");
      Serial.print("1s: ");
      Serial.print(ones);
      Serial.println("");
      colorArray[y] = random(1, 5); //Assigning a random number (1-4) to the colorArray[y], y being the turn count
      for (int x=0; x <= turn; x++)
      {
        Serial.print(colorArray[x]);
      
        for(int y=0; y<1; y++)
        {
      
          if (colorArray[x] == 1) 
          {  //if statements to display the stored values in the array: Display this part of NeoPixel while game is showing order of LEDS
            topLeft();
            tone(speakerpin, NOTE_G3, 100);
            delay(100*pace);
             //Random melody to remain NeoPixel off while between notes
            pixelsOff();
            delay(50*pace);
          }

          if (colorArray[x] == 2) 
          {
            botLeft();
            tone(speakerpin, NOTE_A3, 100);
            delay(100*pace);
            pixelsOff();
            delay(50*pace);
          }
  
          if (colorArray[x] == 3) 
          {
            botRight();
            tone(speakerpin, NOTE_B3, 100);
            delay(100*pace);
            pixelsOff();
            delay(50*pace);
          }

          if (colorArray[x] == 4) 
          {
            topRight();
            tone(speakerpin, NOTE_C4, 100);
            delay(100*pace);
            pixelsOff();
            delay(50*pace);
          }
        }
      }
    }
    input();
  }
}
void twoPlayer(){
     
  }
  
void pointCounter(uint32_t c10, uint32_t c1, uint8_t tens, uint8_t ones){ 
    //tens and ones are integers for how many points are scored
    pixelsOff();
    if ((tens*10 + ones) > (EEPROM.read(addr1)*10 + EEPROM.read(addr2))){       
        hitens = tens;
        hiones = ones;
        EEPROM.write(addr1, hitens);
        EEPROM.write(addr2, hiones);
        highScoreSound();
      }
    delay(500);
    for (int j=0; j<tens; j++) {
      for (int q=0; q < 1; q++) {
              for (uint16_t i=0; i < strip.numPixels(); i=i+1) {
        strip.setPixelColor(i+q, c10);    //turn every pixel on
      }
         strip.show();
         tone(speakerpin, NOTE_B2, 100);
         delay(100);
         tone(speakerpin, NOTE_E3, 200);
         delay(400);
         pixelsOff();
         delay(400);
      }
    }
        for (int j=0; j<ones; j++) {
      for (int q=0; q < 1; q++) {
              for (uint16_t i=0; i < strip.numPixels(); i=i+1) {
        strip.setPixelColor(i+q, c1);    //turn every pixel on
      }
         strip.show();
         
         tone(speakerpin, NOTE_B5, 100);
         delay(100);
         tone(speakerpin, NOTE_E6, 200);
         delay(400);
         pixelsOff();
         delay(400);
      }
    }
    delay(100);
    restart = true;
    while (restart == true){ 
        start();
      }
    //turn = -1;
  }
  void highScore(uint32_t c10, uint32_t c1){
        pixelsOff();
        highScoreSound();
        delay(500);
            for (int j=0; j<EEPROM.read(addr1); j++) {
      for (int q=0; q < 1; q++) {
              for (uint16_t i=0; i < strip.numPixels(); i=i+1) {
        strip.setPixelColor(i+q, c10);    //turn every pixel on
      }
         strip.show();
         tone(speakerpin, NOTE_B2, 100);
         delay(100);
         tone(speakerpin, NOTE_E3, 200);
         delay(400);
         pixelsOff();
         delay(400);
      }
    }
        for (int j=0; j<EEPROM.read(addr2); j++) {
      for (int q=0; q < 1; q++) {
              for (uint16_t i=0; i < strip.numPixels(); i=i+1) {
        strip.setPixelColor(i+q, c1);    //turn every pixel on
      }
         strip.show();
         
         tone(speakerpin, NOTE_B5, 100);
         delay(100);
         tone(speakerpin, NOTE_E6, 200);
         delay(400);
         pixelsOff();
         delay(400);
      }
    }
      }

    void highScoreSound() {
            tone(speakerpin, NOTE_E3, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_F3, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_FS3, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_G3, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_GS3, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_A3, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_AS3, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_B3, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
            
      tone(speakerpin, NOTE_C4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_CS4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_D4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_DS4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);

                  tone(speakerpin, NOTE_E4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_F4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_FS4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_G4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_GS4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_A4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_AS4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_B4, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
            
      tone(speakerpin, NOTE_C5, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_CS5, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_D5, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
      tone(speakerpin, NOTE_DS5, highscoredelay);
      delay(highscoredelay);
      noTone(speakerpin);
      delay(highscoredelay);
  }
  
